package jalview.util.dialogrunner;

import org.testng.Assert;
import org.testng.annotations.Test;

public class RunResponseTest
{
  @Test
  public void testRunResponse()
  {

    RunResponse rr = new RunResponse("OK")
    {
      @Override
      public void run()
      {
        returned = new Response("DONE");
      }
    };
    Assert.assertEquals(rr.ourTrigger, new Response("OK"));
    Assert.assertNotEquals(rr.ourTrigger, new Response("NOTOK"));
    Assert.assertNull(rr.returned);
    Assert.assertFalse(rr.wasRun);
    // trivial ..
    rr.wasRun = true;
    rr.run();
    Assert.assertTrue(rr.wasRun);

    Assert.assertEquals(rr.returned, new Response("DONE"));
    rr.reset();
    Assert.assertNull(rr.returned);
    Assert.assertFalse(rr.wasRun);

    Assert.assertEquals(rr.toString(), "Runner for " + new Response("OK"));

    // just test the other constructors
    RunResponse rr12 = new RunResponse(12)
    {
      @Override
      public void run()
      {
        returned = new Response("DONE");
      }
    };
    RunResponse rrpi = new RunResponse(new Double(3.142))
    {
      @Override
      public void run()
      {
        returned = new Response("DONE");
      }
    };
    Assert.assertEquals(rr12.ourTrigger, new Response(12));
    Assert.assertEquals(rrpi.ourTrigger,
            new Response(Double.valueOf(3.142)));
}
}
